// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from social_nav_msgs:msg/Pedestrian.idl
// generated code does not contain a copyright notice

#include "social_nav_msgs/msg/detail/pedestrian__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
const rosidl_type_hash_t *
social_nav_msgs__msg__Pedestrian__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x41, 0x66, 0x51, 0x68, 0x16, 0xc1, 0xa0, 0xe3,
      0x8e, 0x5e, 0x55, 0x8b, 0x28, 0x0e, 0xf8, 0x32,
      0x66, 0x92, 0x5a, 0x2a, 0xac, 0x38, 0x1e, 0x98,
      0x0e, 0x3f, 0xde, 0x30, 0xe6, 0x50, 0x2b, 0x06,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "nav_2d_msgs/msg/detail/twist2_d__functions.h"
#include "geometry_msgs/msg/detail/pose2_d__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Pose2D__EXPECTED_HASH = {1, {
    0xd6, 0x8e, 0xfa, 0x5b, 0x46, 0xe7, 0x0f, 0x7b,
    0x16, 0xca, 0x23, 0x08, 0x54, 0x74, 0xfd, 0xac,
    0x5a, 0x44, 0xb6, 0x38, 0x78, 0x3e, 0xc4, 0x2f,
    0x66, 0x1d, 0xa6, 0x4d, 0xa4, 0x72, 0x4c, 0xcc,
  }};
static const rosidl_type_hash_t nav_2d_msgs__msg__Twist2D__EXPECTED_HASH = {1, {
    0x33, 0xa3, 0xa4, 0x7d, 0x7b, 0x3a, 0xaa, 0xd5,
    0x37, 0x6a, 0x48, 0x25, 0x05, 0x97, 0x09, 0x3f,
    0xeb, 0x4b, 0x92, 0xab, 0x87, 0x06, 0xc9, 0x6d,
    0xca, 0x69, 0xf4, 0x7d, 0x9a, 0x98, 0x07, 0xd0,
  }};
#endif

static char social_nav_msgs__msg__Pedestrian__TYPE_NAME[] = "social_nav_msgs/msg/Pedestrian";
static char geometry_msgs__msg__Pose2D__TYPE_NAME[] = "geometry_msgs/msg/Pose2D";
static char nav_2d_msgs__msg__Twist2D__TYPE_NAME[] = "nav_2d_msgs/msg/Twist2D";

// Define type names, field names, and default values
static char social_nav_msgs__msg__Pedestrian__FIELD_NAME__identifier[] = "identifier";
static char social_nav_msgs__msg__Pedestrian__FIELD_NAME__pose[] = "pose";
static char social_nav_msgs__msg__Pedestrian__FIELD_NAME__velocity[] = "velocity";

static rosidl_runtime_c__type_description__Field social_nav_msgs__msg__Pedestrian__FIELDS[] = {
  {
    {social_nav_msgs__msg__Pedestrian__FIELD_NAME__identifier, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {social_nav_msgs__msg__Pedestrian__FIELD_NAME__pose, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {geometry_msgs__msg__Pose2D__TYPE_NAME, 24, 24},
    },
    {NULL, 0, 0},
  },
  {
    {social_nav_msgs__msg__Pedestrian__FIELD_NAME__velocity, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {nav_2d_msgs__msg__Twist2D__TYPE_NAME, 23, 23},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription social_nav_msgs__msg__Pedestrian__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Pose2D__TYPE_NAME, 24, 24},
    {NULL, 0, 0},
  },
  {
    {nav_2d_msgs__msg__Twist2D__TYPE_NAME, 23, 23},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
social_nav_msgs__msg__Pedestrian__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {social_nav_msgs__msg__Pedestrian__TYPE_NAME, 30, 30},
      {social_nav_msgs__msg__Pedestrian__FIELDS, 3, 3},
    },
    {social_nav_msgs__msg__Pedestrian__REFERENCED_TYPE_DESCRIPTIONS, 2, 2},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Pose2D__EXPECTED_HASH, geometry_msgs__msg__Pose2D__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Pose2D__get_type_description(NULL)->type_description.fields;
    assert(0 == memcmp(&nav_2d_msgs__msg__Twist2D__EXPECTED_HASH, nav_2d_msgs__msg__Twist2D__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[1].fields = nav_2d_msgs__msg__Twist2D__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "string identifier\n"
  "\n"
  "# pose and velocity are relative to the same frame\n"
  "# i.e. if a pedestrian starts at x=1, y=0, facing positive y (i.e. theta=90deg)\n"
  "#      and was walking forward at 1 m/s, the velocity should be x=0, y=1, theta=0\n"
  "geometry_msgs/Pose2D pose\n"
  "nav_2d_msgs/Twist2D velocity";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
social_nav_msgs__msg__Pedestrian__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {social_nav_msgs__msg__Pedestrian__TYPE_NAME, 30, 30},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 287, 287},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
social_nav_msgs__msg__Pedestrian__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[3];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 3, 3};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *social_nav_msgs__msg__Pedestrian__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Pose2D__get_individual_type_description_source(NULL);
    sources[2] = *nav_2d_msgs__msg__Twist2D__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
